from math import *
import numpy as np
import matplotlib.mlab as mlab
import matplotlib.pyplot as plt


c0 = (1+sqrt(3))/(4*sqrt(2))
c1 = (3+sqrt(3))/(4*sqrt(2))
c2 = (3-sqrt(3))/(4*sqrt(2))
c3 = (1-sqrt(3))/(4*sqrt(2))


def unmix(vec):
    """takes a list of even length and seperates even indices first, odd last
    [0,2,4,6 ... N-4,N-2, 1,3,5,7,...N-3, N-1]
    """
    N= len(vec)
    indices = [2*i for i in range(N/2)] + [2*i+1 for i in range(N/2)]
    return [vec[ind] for ind in indices]
    
def mix(vec):
    """takes a list of even length and interdigitates the first and second havles.
    [0, N/2, 1, N/2+1,  ... N/2-1, N-1 ]"""
    res = []
    n = len(vec)
    for i in range(n):
        if i%2==0:
            res.append(vec[i/2])
        else:
            res.append(vec[(n/2)+(i-1)/2])
    return res

def inverse_M(vec):
    n = len(vec)
    res =[]
    for i in range(n):
        if (i%2)==0:
            x_out = c2*vec[(i-2)%n] + c1*vec[(i-1)%n] + c0*vec[i] + c3*vec[i+1]
        else:
            x_out = c3*vec[(i-3)%n] - c0*vec[(i-2)%n] + c1*vec[(i-1)%n] - c2*vec[1]
        res.append(x_out)
    return res

def inverse_wavelet(vec):

    x_vec = vec[:2]
    w_vec = vec[2:]

    while w_vec:
        n = len(x_vec)
        current_w = w_vec[:n]
        w_vec = w_vec[n:]
        xw = mix(x_vec+current_w)
        x_vec = inverse_M(xw)
    return x_vec
        

in_wav = [0] * (2**12)
in_wav[99]  = 1
in_wav[100]  = 1
#in_wav[30] = 1 

iw =  inverse_wavelet(in_wav)
plt.plot(iw)
plt.show()

